// Sample file provided by Nicolas Bonneel (http://www.bonneel.com)
// TreeGenerator sample (http://www.treegenerator.com)

sampler2D tex0 : TEXUNIT0;

void customCasterVp(float4 position : POSITION,
			  float2 uv : TEXCOORD0,
			  out float2 oUv : TEXCOORD0,
			  out float oDepth : TEXCOORD1,
			  out float4 oPosition : POSITION,
			  uniform float4x4 worldViewProj)
{
   oPosition = mul(worldViewProj, position);
   oUv = uv;
   oDepth = oPosition.z;
}


void customCasterFp(
			float2 texcoord : TEXCOORD0,
			float  depth    : TEXCOORD1,
			out float4 oColor : COLOR)
{
   oColor = depth*0.001;
   
   float4 diffuseTex = tex2Dproj(tex0,float4(texcoord,1,1));
   oColor.a = diffuseTex.a; // handle transparency properly (alpha reject)

} 